
#    RunControl specific for AIDA Project


namespace eval DataAcquisition {
     variable PROJECT; if {![info exists PROJECT]} {set PROJECT AIDA}
     variable ACQSERVERS; if {![info exists ACQSERVERS]} {set ACQSERVERS [list [exec uname -n]]}
     variable ACQSERVER; if {![info exists ACQSERVER]} {set ACQSERVER [first $ACQSERVERS]}
}

namespace eval AIDA {
    variable DBRootName; if {![info exists DBRootName]} {set DBRootName EXPERIMENTS/AIDA}
    variable DBNodeBase; if {![info exists DBNodeBase]} {set DBNodeBase undefined}
    variable DBNodeName; if {![info exists DBNodeName]} {set DBNodeName [exec uname -n]}
}

puts "loading tcl/AIDARunControl.tcl for namespace [namespace current]"

  if {[llength $::DataAcquisition::ACQSERVERS] > 1} {

    set z [catch {package require RunControlClient} m]
    if {$z != 0} {puts "RunControlClient returned z=$z and $m"} else {puts "RunControlClient loaded"}

namespace eval DataAcquisitionControl {
     variable PostSetup_Exists 1
     variable PreReset_Exists 1

   proc do_PreReset {} {
      variable INFO

puts "executing do_PreReset"

      set INFO ""

      if {![info exists ::MASTERTS::started]} {

          append INFO   "var MasterTSWindow = null\;"

          append INFO   "MasterTSWindow = window.open(\"../AIDA/MasterTS/MasterTS.tml\",\"MasterTSWindow\")\;"

#          append INFO   "MasterTSWindow.close()\;"
      }

puts "done executing do_PreReset"

      return 0
   }

   proc do_PostSetup {} {
      variable JS

puts "executing do_PostSetup"

      set z [catch {::MASTERTS::do_ReSYNC} JS]

puts "done executing do_PostSetup"

      return 0
   }
}

  } else {

    set z [catch {package require RunControlServer} m]
    if {$z != 0} {puts "RunControlServer returned z=$z and $m"} else {puts "RunControlServer loaded"}


#    provides the following 

#   Appdo_Setup
#   Appdo_Stop
#   Appdo_Go
#   Appdo_Reset
#   Appdo_SetOption
#   Appdo_GetOption
#   Appdo_GetCounters
#   Appdo_GetRates
#   Appdo_GetState


   global env

     set f [file join $env(MIDASBASE) TclHttpd Html RunControl implementation.tcl]
     set env(ProjectRunControlImplementation) $f
     set z [catch {source $f} m]
     if {$z != 0} {puts "RunControl returned z=$z and $m"} else {puts "RunControl loaded"}

     set f [file join $env(MIDASBASE) TclHttpd Html AIDA RunControl implementation.tcl]
     set env(ProjectRunControlImplementation) $f
     set z [catch {source $f} m]
     if {$z != 0} {puts "AIDA RunControl returned z=$z and $m"} else {puts "AIDA RunControl loaded"}

  }

#global MIDAS_AIDARunControl_Exists
#set MIDAS_AIDARunControl_Exists 1

package provide AIDARunControl 1.0
