

#variable started 0

if {![info exists started]} {variable started 0}

if {$started != 0} {

    variable JS ""
     variable LogFlag

     if {$LogFlag == 1} {InsertLog "Last Updated: [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"}

    do_click

    get_pulser     ;#  update values

}

if {$started == 0} {           ;#  first time load code and define local variables
    set started 1

    variable ShowLogFlag 0

    variable LogText ""
    variable LogFlag 0
    variable LogCount 0

    variable JS ""

    variable HelpTopic "Preamp"

    variable AttenuationList
    variable FrequencyList
    variable ModeList
    variable Attenuation
    variable Frequency
    variable Mode
    variable Enable
    variable CFD
    variable Pulser

    variable PreAmpDAC 0

    variable R14 0
    variable R15 0

    set AttenuationList { \
       "40 dB"  \
       "30 dB"  \
       "20 dB"  \
       "10 dB"  \
       "none"   \
    }

    set FrequencyList {  \
       "100 Hz"   \
       "200 Hz"   \
       "400 Hz"   \
       "800 Hz"   \
       "1600 Hz"   \
       "3200 Hz"   \
       "6400 Hz"   \
       "SYNC pulse"  \
    }

    set ModeList { \
       "rectangular"  \
       "exponential"  \
    }

    set Attenuation [lindex $AttenuationList 0]
    set Frequency [lindex $FrequencyList 0]
    set Mode [lindex $ModeList 0]

    set Enable 0
    set CFD 0
    set Pulser 0


    proc set_pulser {W} {
       variable Attenuation
       variable Frequency
       variable Mode
       variable Enable
       variable CFD
       variable Pulser
       variable PreAmpDAC

       variable AttenuationList
       variable FrequencyList
       variable ModeList

       variable LogFlag

     if {$W == "CTRL"} {

#    Set Pulser Control Register (Offset 14)

       set attenuation [lindex [list 0 8 12 14 15] [lsearch $AttenuationList $Attenuation]]
       set frequency [lindex [list 0 1 2 3 4 5 6 7] [lsearch $FrequencyList $Frequency]]
       set mode [lindex [list 0 1] [lsearch $ModeList $Mode]]

        set Value  [expr (((((((((($frequency << 1) + $Enable) << 1) + $CFD) << 2) + $Pulser) << 1) + $mode) << 7) + $attenuation )]
        set Addr 14
     }

     if {$W == "DAC"} {

#    Set Pulser DAC (Offset 15)

        set Value  $PreAmpDAC
        set Addr 15
     }

        if {$LogFlag == 1} {InsertLog "Setting Pulser Control ([set Addr]) = $Value [format "0x%x" [set Value]]"}

        set rc [set_pulser_register $Addr $Value]

    }

    proc get_pulser {} {
       variable Attenuation
       variable Frequency
       variable Mode
       variable Enable
       variable CFD
       variable Pulser
       variable PreAmpDAC

       variable AttenuationList
       variable FrequencyList
       variable ModeList

       variable R14
       variable R15

        set R14 [get_pulser_register 14]
        if {$R14 == -1} {return}         ;# read error

        set R15 [get_pulser_register 15]
        if {$R15 == -1} {return}         ;# read error

        set PreAmpDAC  $R15
        set attenuation  [expr $R14 & 15]
        set mode [expr ($R14 >> 7) & 1]
        set Pulser [expr ($R14 >> 8) & 1]
        set CFD [expr ($R14 >> 10) & 1]
        set Enable [expr ($R14 >> 11) & 1]
        set frequency [expr ($R14 >> 12) & 7]

        if {[lsearch [list 0 8 12 14 15] $attenuation] == -1} {
           Alert "Bad value returned: Offset 14=0x[format "%x" $R14]"
           set Attenuation [lindex $AttenuationList 0]
        } else {
           set Attenuation [lindex $AttenuationList [lsearch [list 0 8 12 14 15] $attenuation]]
        }

        if {[lsearch [list 0 1 2 3 4 5 6 7] $frequency] == -1} {
           Alert "Bad value returned: Offset 14=0x[format "%x" $R14]"
           set Frequency [lindex $FrequencyList 0]
        } else {
            set Frequency [lindex $FrequencyList [lsearch [list 0 1 2 3 4 5 6 7] $frequency]]
        }

        set Mode [lindex $ModeList $mode]

    }

   proc  show_variables {} {
       variable Attenuation
       variable Frequency
       variable Mode
       variable Enable
       variable CFD
       variable Pulser
       variable PreAmpDAC
       variable R14
       variable R15

        InsertLog "Attenuation=$Attenuation; Frequency=$Frequency; Mode=$Mode; Enable=$Enable; CFD=$CFD; Pulser=$Pulser; PreAmpDAC=$PreAmpDAC"
        InsertLog "R14=$R14; R15=$R15"
   }

   proc  do_click {}  {
       variable cgidata
       variable started
       variable LogFlag
       variable ShowLogFlag

      set cgidata [ncgi::nvlist]

      if {$LogFlag == 1} {InsertLog "cgidata= ([llength $cgidata]) $cgidata"}

      if {[llength $cgidata] == 0} then {return}

      if {[llength $cgidata] < 2} then {
         InsertLog "CGI data is too short: $cgidata"
      } else {
        if {[lindex $cgidata 0] != "Widget"} then {
            InsertLog "Invalid CGI data: $cgidata"
        } else {

           set w [first [lindex $cgidata 1]]
           set vl [second [lindex $cgidata 1]]

           switch -glob $w {

                RESET    {set started 0}
                CLEAR    {EmptyLog}
                ELOG     {PrintLog}
                SELECT   {}
                RELOAD   {}
                VARIABLES {show_variables}

                HIDE     {set ShowLogFlag 0}
                SHOW     {set ShowLogFlag 1}
                   LOGON    {set LogFlag 1}
                   LOGOFF   {set LogFlag 0}

                HELP     {do_help}

                CFD       -
                Pulser    -
                Enable    {variable $w; set $w $vl; set_pulser CTRL}

                PreAmpDAC {variable $w; set $w $vl; set_pulser DAC}

                Param     {variable $vl; set $vl [lreplace [lindex $cgidata 1] 0 1]; set_pulser CTRL}

                MainLog {}
                undefined {}
                default  {if {$rc == 0} {InsertLog "unexpected cgi data:  $cgidata"}}
            }
         }
       }
    }

    get_pulser

}  ;# end of if {$started == 0}



