
#variable started 0

if {![info exists started]} {variable started 0}

if {$started != 0} {

    variable JS ""
    variable LogFlag

   if {$LogFlag == 1} {InsertLog "Last Updated: [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"}

    do_click

}

if {$started == 0} {
    set started 1

    variable ShowLogFlag 0

    variable LogText ""
    variable LogFlag 0
    variable LogCount 0

    variable JS ""

    variable HelpTopic "Diagnostics"

    variable Address         0x0000
    variable Data            0x0000
    variable DataBlock       0x0000
    variable Length          1
    variable AddressModifier A16

   proc  show_variables {} {
        variable Address
        variable Data
        variable DataBlock
        variable Length
        variable AddressModifier

        variable  Digitizer
        variable  NumDigitizer
        variable  Fpga 

      upvar #0 AGATADigitizerAccessServer_MaxDigitizer MaxDigitizer
      upvar #0 AGATADigitizerAccessServer_XportList XportList

        InsertLog "NumDigitizer= [set NumDigitizer]"

        for {set i 0} {$i < $MaxDigitizer} {incr i} {
           InsertLog "$i: [set XportList($i)]"
        }

        InsertLog "Digitizer=$Digitizer; Fpga=$Fpga; AddressModifier=$AddressModifier"
        InsertLog "Address=$Address; Data=$Data; Length=$Length; DataBlock=$DataBlock"
   }

   proc  do_click {}  {
       variable cgidata
       variable started
       variable LogTex
       variable ShowLogFlag
       variable LogFlag

       set cgidata [ncgi::nvlist]

       if {$LogFlag == 1} {InsertLog "cgidata= ([llength $cgidata]) $cgidata"}

       if {[llength $cgidata] == 0} then {return}

       if {[llength $cgidata] < 2} then {
          InsertLog "CGI data is too short: $cgidata"
       } else {
          if {[lindex $cgidata 0] != "Widget"} then {
             InsertLog "Invalid CGI data: $cgidata"
          } else {
 
            switch -glob [first [lindex $cgidata 1]] {

                RESET    {set started 0}
                   CLEAR    {EmptyLog}
                   ELOG     {PrintLog}
                SELECT   {}
                RELOAD   {}
                VARIABLES {show_variables}

                HIDE     {set ShowLogFlag 0}
                SHOW     {set ShowLogFlag 1}
                   LOGON    {set LogFlag 1}
                   LOGOFF   {set LogFlag 0}

                HELP     {do_help}

                PROBE    {click-probe}

                LENGTH   {variable Length; set Length [second [lindex $cgidata 1]]}
                ADDRESS  {variable Address; set Address [second [lindex $cgidata 1]]}
                DATA     {variable Data; set Data [second [lindex $cgidata 1]]}
                BLOCK    {variable DataBlock; set DataBlock [string range [lindex $cgidata 1] 6 end]}
                ADDRMOD  {variable AddressModifier; set AddressModifier [second [lindex $cgidata 1]]}
                FPGA     {variable Fpga; set Fpga [string range [lindex $cgidata 1] 5 end]}
                DIGITIZER  {selectDigitizer [second [lindex $cgidata 1]]}

                SET      {do_set}
                GET      {do_get}
                READ     {do_read}
                WRITE    {do_write}

                undefined {}
                default {InsertLog "unexpected CGI data:  $cgidata"}
            }
         }
      }
   }

   EnumerateDigitizers
   selectDigitizer [first $DigitizerList]

}   ;# end of if {$started == 0} 

