
#    Note:  This is loaded into the namespace  ASIC

# variable started 0

if {![info exists started]} {variable started 0}

if {$started != 0} {

     variable JS ""
     variable LogFlag

     if {$LogFlag == 1} {InsertLog "Last Updated: [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"}

    do_click
}

if {$started == 0} {           ;#  first time load code and define local variables
    set started 1

    variable ShowLogFlag 0

    variable LogText ""
    variable LogFlag 0
    variable LogCount 0

    variable JS ""

    variable ASICList {1 2 3 4}
    variable ASIC [first $ASICList]

    variable allmodules 0
    variable allasics 0

    for {set i 0} {$i < 28} {incr i} {
        variable Opts.Value$i 0
        variable Opts.Offset$i $i
    }

    variable         Opts.Title0  "preamp reset"
    variable         Opts.Title1  "shaper reset"
    variable         Opts.Title2  "filter reset"
    variable         Opts.Title3  "fast filter reset"
    variable         Opts.Title4  "peak hold reset"
    variable         Opts.Title5  "clamp reset"
    variable         Opts.Title6  "comparator reset"
    variable         Opts.Title7  "hold timing"
    variable         Opts.Title8  "low_ref (pre-amp polarity)"
    variable         Opts.Title9  "shaping time"
    variable         Opts.Title10  "medium/low energy selection"
    variable         Opts.Title11  "clamp threshold"
    variable         Opts.Title12  "slow comparator threshold"
    variable         Opts.Title13  "shaper reference"
    variable         Opts.Title14  "fast comparator threshold HEC"
    variable         Opts.Title15  "fast comparator threshold LEC/MEC"
    variable         Opts.Title16  "vsasc_n for buffers"
    variable         Opts.Title17  "vsasc_p for buffers"
    variable         Opts.Title18  "preAmp reference"
    variable         Opts.Title19  "biasRC preamp HEC"
    variable         Opts.Title20  "vcasc_preamp HEC"
    variable         Opts.Title21  "Ibias LF feedback"
    variable         Opts.Title22  "biasRC preamp"
    variable         Opts.Title23  "Ibias preamp SF"
    variable         Opts.Title24  "vcasc_preamp LEC"
    variable         Opts.Title25  "Ibias preamp"
    variable         Opts.Title26  "diode link threshold"
    variable         Opts.Title27  ""


   proc  show_variables {} {
       variable allmodules 
       variable allasics
       variable ASIC

       InsertLog "FEE64 = $::AIDA::FEE64; ASIC = $ASIC"
       InsertLog "all modules = $allmodules; all asics = $allasics"
   }

   proc do_redisplay {} {
     variable ASIC

     for {set i 0} {$i < 27} {incr i} {
       variable Opts.Value$i
       set Opts.Value$i [ReadAIDARegister [expr 0x4000 + (($ASIC-1)*64) + $i]]
     }
   }

   proc do_setOpt {i vl} {
      variable ASIC
      variable ASICList
      variable allasics
      variable allmodules

      set BAK $::AIDA::FEE64

      foreach fee64 $::AIDA::ModuleMenu {
          if {$allmodules == 0 && $fee64 != $::AIDA::FEE64} continue

          set ::AIDA::FEE64 $fee64
 
          foreach asic $ASICList {
              if {$allasics == 0 && $asic != $ASIC} continue
              WriteAIDARegister [expr 0x4000 + (($asic-1)*64) + $i] $vl
          }
      }

      set ::AIDA::FEE64 $BAK

      LoadASIC
   }

   proc ShowTemps {} {
      variable allmodules

      set BAK $::AIDA::FEE64

      set m ""

      foreach fee64 $::AIDA::ModuleMenu {
          if {$allmodules == 0 && $fee64 != $::AIDA::FEE64} continue

          set ::AIDA::FEE64 $fee64

          WriteAIDARegister 0x200 0          ;#    initiate Virtex temp measurement
          set vl0 [ReadAIDARegister 0x201]   ;#  get it

          WriteAIDARegister 0x202 0          ;#    initiate PSU temp measurement
          set vl1 [ReadAIDARegister 0x203]   ;#  get it

          WriteAIDARegister 0x204 0          ;#    initiate ASIC temp measurement
          set vl2 [ReadAIDARegister 0x205]   ;#  get it

          append m "$::AIDA::FEE64\n\
                      Virtex Temp = [expr $vl0 * 0.0625]C ([format "0x%04x" $vl0])\n\
                      PSU Temp = [expr $vl1 * 0.0625]C ([format "0x%04x" $vl1])\n\
                      ASIC Temp = [expr $vl2 * 0.0625]C ([format "0x%04x" $vl2])\n"
      }

      set ::AIDA::FEE64 $BAK
     
      Alert $m

     return $m

   }

   proc LoadASIC  {} {
      variable ASIC
      variable ASICList
      variable allasics
      variable allmodules

      set BAK $::AIDA::FEE64

      foreach fee64 $::AIDA::ModuleMenu {
          if {$allmodules == 0 && $fee64 != $::AIDA::FEE64} continue

          set ::AIDA::FEE64 $fee64
 
          foreach asic $ASICList {
             if {$allasics == 0 && $asic != $ASIC} continue
             WriteAIDARegister [expr 0x4000 + (($asic-1)*64) + 28] 0   ;#  load control registers
          }
      }
      set ::AIDA::FEE64 $BAK
   }

   proc CheckASIC {} {
       variable ASIC
       variable ASICList
       variable allasics
      variable allmodules

      set BAK $::AIDA::FEE64

      foreach fee64 $::AIDA::ModuleMenu {
          if {$allmodules == 0 && $fee64 != $::AIDA::FEE64} continue

          set ::AIDA::FEE64 $fee64

      foreach asic $ASICList {
         if {$allasics == 0 && $asic != $ASIC} continue

         WriteAIDARegister [expr 0x4000 + (($asic-1)*64) + 28] 0   ;#  load control registers twice
         WriteAIDARegister [expr 0x4000 + (($asic-1)*64) + 28] 0  

         for {set i 0} {$i < 5} {incr i} {
            set addr [expr 0x4000 + (($asic-1)*64) + $i + 32]
            set C$i [ReadAIDARegister $addr]
         }

         for {set i 0} {$i < 5} {incr i} {
            set addr [expr 0x4000 + (($asic-1)*64) + $i + 40]
            set R$i [ReadAIDARegister $addr]
         }

#    now perform check

         for {set i 0} {$i < 5} {incr i} {
             if {[set C$i] != [set R$i]} {
                Alert "ASIC load check failed\n\
                   TxR [format 0x%08x $C0] [format 0x%08x $C1] [format 0x%08x $C2]\
                        [format 0x%08x $C3] [format 0x%08x $C4]\n\
                   RxR [format 0x%08x $R0] [format 0x%08x $R1] [format 0x%08x $R2]\
                        [format 0x%08x $C3] [format 0x%08x $R4]\n"
                return
             }
         }

         InsertLog "$::AIDA::FEE64: ASIC $asic load check OK"
      }
      }
      set ::AIDA::FEE64 $BAK
   }

   proc DEFAULT {} {
       variable ASIC
       variable ASICList
       variable allasics
      variable allmodules

      set BAK ::AIDA::FEE64

      foreach fee64 $::AIDA::ModuleMenu {
          if {$allmodules == 0 && $fee64 != $::AIDA::FEE64} continue

          set ::AIDA::FEE64 $fee64

          foreach asic $ASICList {
             if {$allasics == 0 && $asic != $ASIC} continue
             WriteAIDARegister [expr 0x4000 + (($asic-1)*64) + 30] 0
          }
      }
      set ::AIDA::FEE64 $BAK

      LoadASIC
   }


   proc  do_click {}  {
       variable cgidata
       variable started
       variable LogFlag
       variable ShowLogFlag

       set cgidata [ncgi::nvlist]

       if {$LogFlag == 1} {InsertLog "cgidata= ([llength $cgidata]) $cgidata"}

       if {[llength $cgidata] == 0} then {return}

       if {[llength $cgidata] < 2} then {
           InsertLog "CGI data is too short: $cgidata"
       } else {
           if {[lindex $cgidata 0] != "Widget"} then {
               InsertLog "Invalid CGI data: $cgidata"
           } else {

              set w [first [lindex $cgidata 1]]
              set vl [second [lindex $cgidata 1]]

               switch -glob $w {

                   RESET    {set started 0}
                   CLEAR    {EmptyLog}
                   ELOG     {PrintLog}
                   RELOAD   {}
                   VARIABLES {show_variables}

                   HIDE     {set ShowLogFlag 0}
                   SHOW     {set ShowLogFlag 1}
                   LOGON    {set LogFlag 1}
                   LOGOFF   {set LogFlag 0}

                   MODULE     {set ::AIDA::FEE64 $vl}
                   ALLMODULES {variable allmodules; set allmodules [expr ($allmodules + 1) & 1]}

                   ASIC     {variable ASIC; set ASIC $vl}
                   ALLASICS {variable allasics; set allasics [expr ($allasics + 1) & 1]}

                   OPTS     {do_setOpt [second [lindex $cgidata 1]] [third [lindex $cgidata 1]]}
                   EXPERT   {$vl}

                   MainLog {}
                   undefined {}
                   default {InsertLog "unexpected CGI data:  $cgidata"}
               }
           }
        }
        do_redisplay
     }

     do_redisplay

}   ;# end of if {$started == 0}




