
#    Note:  This is loaded into the namespace  AIDA_SpecSave

# variable started 0

if {![info exists started]} {variable started 0}

if {$started != 0} {

     variable JS ""
     variable LogFlag

    if {$LogFlag == 1} {InsertLog "Last Updated: [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"}

    do_click

#     do_DBUpdate
}

if {$started == 0} {           ;#  first time load code and define local variables
    set started 1

    variable LogText ""
    variable LogFlag 0
    variable LogCount 0

    variable ShowLogFlag 0

    variable JS ""

#    variable DBNameList {"xxx"}

   variable index 0
   variable selected 0


   proc show_variables {} {
        variable LogFlag
        variable ShowLogFlag
        variable selected

        InsertLog "LogFlag=$LogFlag; ShowLogFlag=$ShowLogFlag"
        InsertLog "selected=$selected"
#        InsertLog "DBPath = $::AIDA::DBRootName/$::AIDA::DBNodeBase/$::AIDA::DBNodeName"

        foreach fee64 $::AIDA::ModuleMenu {InsertLog "$fee64"}


#        InsertLog "HasBeenConfigured = [ReadRegister HasBeenConfigured]"
#        InsertLog "HasBeenRestored = [ReadRegister HasBeenRestored]"
   }

      proc Selection {} {
          variable selected

          set selected 0;   return    ;# while save is very slow

           set i 1
           foreach item $::AIDA::ModuleMenu {
               set selected [expr $selected | (1 << $i)]
               incr i
           }
      }

      proc do_Select {i} {
         variable selected

         set selected [expr $selected | (1 << $i)]
      }

      proc do_UnSelect {i} {
         variable selected

         set selected [expr $selected & ~(1 << $i)]
      }


#    proc do_setopt {option} {
#        global errorCode errorInfo
#        global DataAcquisitionControlServerHost
#        variable AcqSetOption

#        set AcqSetOption $option	

#        if {$DataAcquisitionControlServerHost != $::DataAcquisition::ACQSERVER} {
#                set DataAcquisitionControlServerHost  $::DataAcquisition::ACQSERVER
#                DataAcquisitionControlClient_Configure
#        }
#        set rc [catch {DataAcquisitionControlClient__DoOption "$AcqSetOption"} m]

#        if {$rc != 0} {
#            InsertLog "DO OPTION returned with an error\n$m\n$errorCode\n$errorInfo"
#        }
#     }

   proc inquire_specnames {} {
       global errorCode errorInfo
       global SpectrumServerHost

           if {$SpectrumServerHost != $::DataAcquisition::ACQSERVER} {
                set SpectrumServerHost  $::DataAcquisition::ACQSERVER
                SpectrumClient_Configure
           }
           set rc [catch {SpectrumClient__InquireSpectra *} msg]
           set m $msg

       if {$rc == 0} {
#           InsertLog "SpecNames returned: $msg"
           set SpectrumList {}
           foreach item $m {lappend SpectrumList $item}
           set SpectrumList [lsort -dictionary $SpectrumList]
       } else {
           InsertLog "SpecNames returned with an error\n$msg\n$errorCode\n$errorInfo"
       }

      return $SpectrumList
   }

   proc SpecSave {} {
      global env
      global SpectrumServerHost


      set f1 [file join $env(MIDASBASE) SpecData [set ::DataAcquisition::PROJECT]]
      set z [catch {file mkdir $f1} m]
      set z [catch {file attributes $f1 -permissions rwxrwxrwx} m]

      set f2 [file join $f1 [date +%Y%h%d-%H.%M.%S]]
      set z [catch {file mkdir $f2} m]
      set z [catch {file attributes $f2 -permissions rwxrwxrwx} m]

      set f3 [file join $f2 $SpectrumServerHost]
      set z [catch {file mkdir $f3} m]
      set z [catch {file attributes $f3 -permissions rwxrwxrwx} m]

      set SpecNames [inquire_specnames]
      set NumSpec 0
      foreach item $SpecNames {
         if {[first $item] != 1} {continue}   ;#   not a valid histogram !!

         set SpecName [second $item]
         set spec [last [split $SpecName .]]
         if {$spec == "H"} {continue}
         if {$spec == "W"} {continue}

         set from [set SpectrumServerHost]:8015/SpectrumService/$SpecName
         set to [file join $f3 $SpecName]

         set execute "exec copy-soap-spectrum  $from $to"
         set rc [catch {eval $execute} m]
      
         if {$rc == 0} {
            InsertLog "$m"
         } else {
            InsertLog "CopySpectrum returns an error: $m"
         }

         incr NumSpec
      }

      InsertLog "$NumSpec Histograms saved to $f2"
#      Elog INFORMATION "Histograms saved to $f2"

     return "$NumSpec Histograms saved to $f2"

   }

      proc do_Save {} {
        variable selected
        global SpectrumServerHost

         if {$selected == 0} {Selection}
      
#        InsertLog "Saving FEE64 histograms to $::AIDA::DBRootName/$::AIDA::DBNodeBase"

         InsertLog "Saving FEE64 histograms"

        set BAK $::AIDA::FEE64   ;# save
        
           set i 1
           foreach fee64 $::AIDA::ModuleMenu {
             if {[expr ($selected >> $i) & 1] == 0} {incr i; continue}

             set ::DataAcquisition::ACQSERVER $fee64

#             do_setopt "HistogramSave"
#    for now we will pull the histograms from the FEEEs rather than get them to perform the SACE in parallel
#

             set SpectrumServerHost $fee64
#             package require SpectrumClient
#             SpectrumClient_Configure

             InsertLog "FEE64 histograms saving for $SpectrumServerHost"

             set rc [catch {SpecSave} m]
             if {$rc == 0} {
                 InsertLog "FEE64 histograms saved for $SpectrumServerHost"
             } else {
                 InsertLog "FEE64 histograms NOT saved for $SpectrumServerHost: $m"
             }

             incr i
          }

        set ::AIDA::FEE64 $BAK    ;# restore

#        InsertLog "FEE64 histograms saved to $::AIDA::DBRootName/$::AIDA::DBNodeBase"

        InsertLog "FEE64 histograms saved"

#        Elog INFORMATION "FEE64 histograms saved to $::AIDA::DBRootName/$::AIDA::DBNodeBase"

#        do_DBUpdate
    }

      proc do_DBName {vl} {
         global Options

          set ::AIDA::DBNodeBase $vl
          DBCreateNode $::AIDA::DBRootName/$::AIDA::DBNodeBase

          InsertLog "Data Base node $::AIDA::DBRootName/$::AIDA::DBNodeBase contains [DBGetNodes $::AIDA::DBRootName/$::AIDA::DBNodeBase *]"
      }

      proc do_DBUpdate {} {
          variable DBNameList

          set DBNameList {}
          foreach item [DBGetNodes $::AIDA::DBRootName *] {
              if {$item == "Options"} continue
              lappend DBNameList $item
          }
      }
    

   proc  do_click {}  {
       variable cgidata
       variable started
       variable LogFlag
       variable ShowLogFlag

      set cgidata [ncgi::nvlist]

      if {$LogFlag == 1} {InsertLog "cgidata= ([llength $cgidata]) $cgidata"}

      if {[llength $cgidata] == 0} then {return}

      if {[llength $cgidata] < 2} then {
         InsertLog "CGI data is too short: $cgidata"
      } else {
        if {[lindex $cgidata 0] != "Widget"} then {
            InsertLog "Invalid CGI data: $cgidata"
        } else {
           set w [lindex $cgidata 1]

           switch -glob [lindex $w 0] {

                RESET    {set started 0}
                CLEAR    {EmptyLog}
                ELOG     {PrintLog}
                RELOAD   {variable selected; if {$selected == 0} {Selection}}
                VARIABLES {show_variables}

                HIDE     {set ShowLogFlag 0}
                SHOW     {set ShowLogFlag 1}
                LOGON    {set LogFlag 1}
                LOGOFF   {set LogFlag 0}

                DBNAMES -
                DBNAME   {do_DBName [lindex $w 1]}

                GENKEY   {do_DBName [date +%Y%h%d-%H.%M.%S]}

                SAVE     {do_Save}
      
                SELECT    {do_Select [lindex $w 1]}
                UNSELECT  {do_UnSelect [lindex $w 1]}

                undefined {}
                default  {InsertLog "unexpected cgi data:  $cgidata"}
            }
         }
       }
    }

   Selection

#     do_DBUpdate

#     load_Options
#     set ::AIDA::DBNodeBase $Options(ASIC.settings)
#     set ::AIDA::DBNodeBase Histograms


}  ;# end of if {$started == 0}

