
#    Note:  This is loaded into the namespace  R3B_Diagnostics

#variable started 0


if {![info exists started]} {variable started 0}

if {$started != 0} {

    variable JS ""
    variable LogFlag

   if {$LogFlag == 1} {InsertLog "Last Updated: [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"}

    do_click

}

if {$started == 0} {
    set started 1

    variable ShowLogFlag 0

    variable LogText ""
    variable LogFlag 0
    variable LogCount 0

    variable JS ""

    variable AddrSpaceList

    variable Offset0x000

    variable AddrSpace
    variable Address
    variable Offset
    variable SData
    variable GData


     set AddrSpaceList [list \
         "Local Control: 0x000" \
    ]

    set Offset0x000 [list \
       "Register0:  0x00"  \
       "Register1:  0x04"  \
       "Register2:  0x08"  \
       "Register3:  0x0c"  \
       "Register4:  0x10"  \
       "Register5:  0x14"  \
       "Register6:  0x18"  \
       "Register7:  0x1c"  \
    ]


    set Address 0x0000
    set AddrSpace [lindex $AddrSpaceList 0]
    set Offset 0
    set SData            0x0000
    set GData            ******

   proc  show_variables {} {
        variable AddrSpace
        variable Address
        variable Offset
        variable SData
        variable GData

        InsertLog "R3B4K = $::R3B::R3B4K"
        InsertLog "AddrSpace=$AddrSpace; Address=$Address; Offset=$Offset; SetData=$SData; GetData=$GData"
   }

   proc  do_click {}  {
       variable cgidata
       variable started
       variable LogText
       variable ShowLogFlag
       variable LogFlag
       variable Address
       variable AddrSpace
       variable Offset
       variable SData
       variable GData

       set cgidata [ncgi::nvlist]

       if {$LogFlag == 1} {InsertLog "cgidata= ([llength $cgidata]) $cgidata"}

       if {[llength $cgidata] == 0} then {return}

       if {[llength $cgidata] < 2} then {
          InsertLog "CGI data is too short: $cgDiagnostics.tmlidata"
       } else {
          if {[lindex $cgidata 0] != "Widget"} then {
             InsertLog "Invalid CGI data: $cgidata"
          } else {

              set w [first [lindex $cgidata 1]]
              set vl [second [lindex $cgidata 1]]

            switch -glob $w {

                RESET    {set started 0}
                   CLEAR    {EmptyLog}
                   ELOG     {PrintLog}
                SELECT   {}
                RELOAD   {}
                VARIABLES {show_variables}

                HIDE     {set ShowLogFlag 0}
                SHOW     {set ShowLogFlag 1}
                   LOGON    {set LogFlag 1}
                   LOGOFF   {set LogFlag 0}

                SET      {WriteR3BRegister [expr $Address + $Offset] $SData}
                GET      {set GData [ReadR3BRegister [expr $Address + $Offset]]}
                SETGET   {
                    WriteR3BRegister [expr $Address + $Offset] $SData
                    set GData [ReadR3BRegister [expr $Address + $Offset]]
                }

                ADDRSPACE  {
                    set Address [last [lindex $cgidata 1]]
                    set AddrSpace "[lreplace [lindex $cgidata 1] 0 0]"
                    set Offset 0
                }
                OFFSET     {set Offset [last [lindex $cgidata 1]]}
                SDATA      {set SData  [last [lindex $cgidata 1]]}

                MODULE     {set ::R3B::R3B4K $vl}

                MainLog {}
                undefined {}
                default {InsertLog "unexpected CGI data:  $cgidata"}
            }
         }
      }
   }

}   ;# end of if {$started == 0} 

