
# variable started 0

if {![info exists started]} {variable started 0}

if {$started != 0} {

     variable JS ""
     variable LogFlag

     if {$LogFlag == 1} {InsertLog "Last Updated: [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"}

    do_click
}

if {$started == 0} {           ;#  first time load code and define local variables
    set started 1

    variable LogText ""
    variable LogFlag 0
    variable LogCount 0

    variable ShowLogFlag 0

    variable JS ""

    variable Command ""

    variable RSHSERVERS
    if {![info exists RSHSERVERS] || [llength RSHSERVERS] == 0} {set RSHSERVERS [list [exec uname -n]]}
    variable RSHSERVER [first $RSHSERVERS]

    variable allservers 0


   proc show_variables {} {
        variable LogFlag
        variable ShowLogFlag
        variable Command
       variable allservers
       variable RSHSERVER

         InsertLog "LogFlag=$LogFlag; ShowLogFlag=$ShowLogFlag"
         InsertLog "RSHServer=$RSHSERVER; allservers=$allservers"
         InsertLog "Command=$Command"
   }

   proc  ExecuteCommand {} {
       global errorCode errorInfo
       variable Command
       variable allservers
       variable RSHSERVER
       variable RSHSERVERS
       global  RshServerHost 

      set BAK $RSHSERVER

      foreach server $RSHSERVERS {
          if {$allservers == 0 && $server != $RSHSERVER} continue

          set RSHSERVER $server

          if {$RSHSERVER == [first $RSHSERVERS]} then {
             set rc [catch {::namespace inscope ::urn:RshServer Rsh "$Command"} m]
             if {$rc == 0} {set m [lindex $m 5]}
          } else {
             if {$RshServerHost != $RSHSERVER} {
                set RshServerHost  $RSHSERVER
                RshClient_Configure
             }
             set rc [catch {RshClient__Rsh "$Command"} m]
          }

          if {$rc == 0} {
             InsertLog "Command Executed: Response received from $RSHSERVER\n$m"
          } else {
             InsertLog "ExecuteCommand failed: Code= $errorCode; Info= [first [split $errorInfo \n]]"
             InsertLog "ExecuteCommand returned\n$m"
          }

       }

       set RSHSERVER $BAK

    }

     proc do_click {} {
       variable cgidata
       variable started
       variable LogFlag
       variable ShowLogFlag
       variable JS

       variable Command
       variable allservers
       variable RSHSERVER

       set cgidata [ncgi::nvlist]

       if {$LogFlag == 1} {InsertLog "cgidata= ([llength $cgidata]) $cgidata"}

       if {[llength $cgidata] == 0} then {return}

       if {[llength $cgidata] < 2} then {
           InsertLog "CGI data is too short: $cgidata"
       } else {
           if {[lindex $cgidata 0] != "Widget"} then {
               InsertLog "Invalid CGI data: $cgidata"
           } else {
 
              set w [first [lindex $cgidata 1]]
              set vl [second [lindex $cgidata 1]]

               switch -glob [lindex $w 0] {

                   RESET    {set started 0}
                   CLEAR    {EmptyLog}
                   ELOG     {PrintLog}
                   RELOAD   {}
                   VARIABLES {show_variables}

                   COMMAND  {set Command [lindex $cgidata 3]; ExecuteCommand}

                   SERVER     {set RSHSERVER $vl}
                   ALLSERVERS {set allservers [expr ($allservers + 1) & 1]}

                   HIDE     {set ShowLogFlag 0}
                   SHOW     {set ShowLogFlag 1}
                   LOGON    {set LogFlag 1}
                   LOGOFF   {set LogFlag 0}

                   MainLog {}
                   undefined {}
                   default {InsertLog "unexpected CGI data: [lindex $w 0]: $cgidata"}
               }
           }
       }
    }

}   ;# end of if {$started == 0}



