


#variable Started 0

if {![info exists Started]} {variable Started 0}

if {$Started != 0} {

     variable JS ""
     variable LogFlag

     if {$LogFlag == 1} {InsertLog "Last Updated: [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"}

    do_click
    
    if {$Reloading == 1} {
        set Reloading 0
        global env
        source [file join $env(MIDASBASE) TclHttpd tcl Common spectrum.tcl]
        set z [catch {source analysis.tcl} m]
        if {$z != 0} {puts "analysis.tcl returned z=$z and $m"}
    }

}

if {$Started == 0} {           ;#  first time load code and define local variables

#    global MIDAS_SpectrumAccessServer_Exists
#    if {![info exists MIDAS_SpectrumAccessServer_Exists]} then {

       set z [catch {package require SpectrumClient} m]
       if {$z != 0} {puts "SpectrumClient returned z=$z and $m"}
#    }

     global env
     source [file join $env(MIDASBASE) TclHttpd tcl Common spectrum.tcl]

     set z [catch {source analysis.tcl} m]
     if {$z != 0} {puts "analysis.tcl returned z=$z and $m"}

    set Started 1

    variable SpecName "*"
    variable SpecPathName "*"
    variable SpecRawData {}
    variable Compression 1
    variable SpecData ""
    variable SpecCont ""
    variable SpecLength ""
    variable DataLength ""
    variable SpecTitle ""
    variable SpecShow 0
    variable SpectrumList {}
    variable DirectoryList {}
    variable SpecDim 1
    variable SpecB 0
    variable SpecR 0
    variable SpecArgs {}
    variable DataList {}
    variable SearchName 0
    variable XMin 0
    variable XMax 0
    variable YMin 0
    variable YMax 0
    variable CustomYView 0
    variable CanvasX 512
    variable CanvasY 512
    variable SpecBase 0
    variable SpecRange 0
    variable SpecBase0 0
    variable SpecRange0 0
    variable SpecBase 0
    variable SpecSize 0
    variable SpecRange 0
    variable SpecLimit 0
    variable WindowSize 0
    variable Skip0 0
    variable QuikLoad 0
    variable DefCont 0
    variable Showing 0
    variable Reloading 0
    variable copymsg "none"

    variable LogText ""
    variable LogFlag 0
    variable LogCount 0

    variable ShowLogFlag 0

    variable JS ""

    variable MemSas 0
    variable DiscSas 0
    global MemSasAccess_Exists
    if {[info exists MemSasAccess_Exists]}  {set MemSas 1}
    global DiscSasAccess_Exists
    if {[info exists DiscSasAccess_Exists]} {set DiscSas 1}

    if {$MemSas == 0 && $DiscSas == 0} {set MemSas 1}
    
    if {$DiscSas == 1} {
        namespace eval ::DataAcquisition {variable ACQSERVERS; set ACQSERVERS [list localhost]; variable ACQSERVER; set ACQSERVER [lindex $ACQSERVERS 0]}
    }
    
    global tcl_platform
    if {$tcl_platform(platform) == "unix"} {
        variable DirName "/MIDAS/Samples/spectra"
    } else {
        variable DirName "c:/MIDAS/Samples/spectra"
    }
    
    variable numgallery 1
    variable activegallery 1
    
    variable numtag 10
    variable tagx
    variable tagy
    for {set i 1} {$i<=$numtag} {incr i} {set tagx($i) 0; set tagy($i) 0}
    variable ntags 0
    
    variable Colors
    set Colors(1) rgb(0,0,255)   ;# blue
    set Colors(2) rgb(0,255,0)   ;# lime green
    set Colors(3) rgb(255,165,0) ;# orange
    set Colors(4) rgb(255,0,255) ;# magenta
    set Colors(5) rgb(0,255,255) ;# cyan
    set Colors(6) rgb(255,255,0) ;# yellow
    set Colors(7) rgb(128,0,128)   ;# purple
    set Colors(8) rgb(255,192,203)   ;# pink
    set Colors(9) rgb(128,128,0) ;# olive
    set Colors(10) rgb(0,128,128) ;# darn green
    
    set Colors(ActiveGallery) rgb(0,0,0)   ;# black
    set Colors(InActiveGallery) rgb(128,128,128)   ;# black
    set Colors(Crosshair) rgb(0,0,0)   ;# black
    set Colors(11)  rgb(255,0,0)  ;# red
    
    proc show_variables {} {
        variable LogFlag
        variable LogCount
        variable ShowLogFlag
        variable MemSas
        variable DiscSas
        variable SpecName
        variable DirName
        variable SpecTitle
        variable SpecDim
        variable SpecBase
        variable SpecRange
        variable SpecLimit
        variable SpecRawData
        
       variable XMin
       variable XMax
       variable YMin
       variable YMax
       variable SpecSize
       variable SpecLimit
       variable WindowSize

       variable copymsg 
        
       global MIDAS_SpectrumAccessServer_Exists
       global SpectrumServerHost

       InsertLog "AcqServers=$::DataAcquisition::ACQSERVERS"
       InsertLog "AcqServer=$::DataAcquisition::ACQSERVER"

         InsertLog "LogFlag=$LogFlag; LogCount=$LogCount; ShowLogFlag=$ShowLogFlag"
         InsertLog "MemSas=$MemSas; DiscSas=$DiscSas"
         InsertLog "DirName=$DirName; SpecName=$SpecName"
         InsertLog "Spectrum=[SpectrumName]"
         InsertLog "SpecTitle=$SpecTitle; SpecDim=$SpecDim; SpecBase=$SpecBase; SpecRange=$SpecRange; SpecLimit=$SpecLimit"
         InsertLog "XMin=$XMin; XMax=$XMax; YMin=$YMin; YMax=$YMax"
         InsertLog "SpecSize=$SpecSize; WindowSize=$WindowSize; data length=[llength $SpecRawData]"
         InsertLog "last copy spectrum: $copymsg"

       if {[info exists MIDAS_SpectrumAccessServer_Exists]} then {
         InsertLog "MIDAS_SpectrumAccessServer_Exists = $MIDAS_SpectrumAccessServer_Exists"
       }

       if {[info exists SpectrumServerHost]} then {
         InsertLog "SpectrumServerHost = $SpectrumServerHost"
       }
    }
    
    proc SpectrumName {} {
        variable MemSas
        variable DiscSas
        variable DirName
        variable SpecName
        if {$MemSas == 1} {return $SpecName}
        if {$DiscSas == 1} {return [file join $DirName $SpecName]}
    }

    proc load_spectrum {s} {
        global env
        global SpectrumServerHost
        variable DiscSas
        variable QuikLoad
        variable copymsg

        if {$DiscSas == 1} {return $s}   ;#  already a disc PATH name

#    for a MemSas based spectrum we have to copy to a temp file

       if {$QuikLoad == 1} {return "NULL"}
    
#    check for and if necessary create a temporary directory
       if {[midas-check-for-temp] == 0} {return -1}

       set from [set SpectrumServerHost]:8015/SpectrumService/[set s]
       set to [file join $env(MIDASTempDir) tcl[pid] [set SpectrumServerHost]_[set s]]

       set z [catch {file delete -force $to}]   ;#  in case already exists

      set execute "exec copy-soap-spectrum  $from $to"
      set rc [catch {eval $execute} m]
      
      if {$rc == 0} {
          set copymsg "$m"
      } else {
          InsertLog "CopySpectrum returns an error: $m"
      }
       
       return $to
    }

   proc do_show_1d {args} {
       variable SpecDim
       variable SpecRawData
       variable Compression
       variable SpecData
       variable SpecLength
       variable SpecBase
       variable SpecSize
       variable SpecRange
       variable SpecLimit
       variable WindowSize
       variable Skip0
       variable XMin
       variable XMax
       variable YMin
       variable YMax
       variable CustomYView
       variable Showing
       variable SpecShow

           if {$SpecDim != 1} {InsertLog "Spectrum Dimension is $SpecDim in do_show_1d; internal logic error"; return}

           if {$XMin < $SpecBase} {set XMin $SpecBase}
           if {$XMin == $SpecBase && $Skip0} {set XMin [expr $SpecBase + 1]}
           if {$XMax <= $XMin} {set XMax $SpecRange}
           if {$XMax >= $SpecRange} {set XMax [expr $SpecRange - 1]}

           set SpecLength [expr $XMax - $XMin + 1]
           set WindowSize [expr $XMax - $XMin + 1]
           set Compression [expr max(1, $SpecLength / 1024)]
       
           set ymin 0
           set ymax 0
           set SpecData ""
           set k $XMin
           for {set i $XMin} {$i < [expr [llength $SpecRawData] - $Compression]} {} {
              set item 0
              for {set j 0} {$j < $Compression} {incr j} {
#                 incr item [lindex $SpecRawData $i]
                 if {[lindex $SpecRawData $i] > $item} {set item [lindex $SpecRawData $i]}
                 incr i
              }
#              set item [expr $item/$Compression]
              if {$item > $ymax} {set ymax $item}
              if {$item < $ymin} {set ymin $item}
              append SpecData "\[[expr $k],$item\],"
              incr k $Compression
           }
           
           if {$CustomYView == 0} {
               set YMin [expr (round ($ymin*9)/10)]
               set YMax [expr (round ($ymax*11)/10)]
           }
           
           set SpecLimit $ymax
              
       set SpecShow 1
       set Showing 1
   }

   proc do_show_2d {args} {

      InsertLog "Sorry: not at present"
   }

   proc do_show {} {
       variable SpecDim

       switch $SpecDim {

          1  {do_show_1d}
          2  {do_show_2d}
          default {InsertLog "Spectrum Dimension is $SpecDim; only 1d & 2d supported"}
       }
   }

   proc do_loadSpectrum {} {
       variable SpecPathName
       variable SpecTitle
       variable SpecRawData
       variable SpecDim
       variable SpecBase
       variable SpecRange
       variable SpecBase0
       variable SpecRange0
       variable SpecBase1
       variable SpecRange1

       set m [do_details 1]
       if {[first $m] != 0} {return}    ;#   error already reported
       set details [second $m]

       set SpecDim [first $details]

       if {$SpecDim == 1} {
           set SpecBase [second $details]
           set SpecRange [third $details]
       }

       if {$SpecDim == 2} {
           set SpecBase0 [first [second $details]]
           set SpecBase1 [second [second $details]]
           set SpecRange0 [first [third $details]]
           set SpecRange1 [second [third $details]]
       }

       set m [do_title 1]
       if {[first $m] != 0} {return}    ;#   error already reported
       set SpecTitle [second $m]

       if {$SpecDim == 1} {
           set m [do_read1D [SpectrumName] $SpecBase $SpecRange 1]
       }

       if {$SpecDim == 2} {
           set m [do_read2D [SpectrumName] $SpecBase0 $SpecRange0 $SpecBase1 $SpecRange1 1 1]
       }

       if {[first $m] != 0} {return}    ;#   error already reported
       set SpecRawData [second $m]

       set SpecPathName [load_spectrum [SpectrumName]]

   }

   proc do_updateSpectrum {} {
       variable SpecPathName
       variable SpecRawData
       variable SpecDim
       variable SpecBase
       variable SpecRange
       variable SpecBase0
       variable SpecRange0
       variable SpecBase1
       variable SpecRange1
       variable numtag
       variable tagx
       variable tagy

       if {$SpecDim == 1} {
           set m [do_read1D [SpectrumName] $SpecBase $SpecRange 1]
       }

       if {$SpecDim == 2} {
           set m [do_read2D [SpectrumName] $SpecBase0 $SpecRange0 $SpecBase1 $SpecRange1 1 1]
       }

       if {[first $m] != 0} {return}    ;#   error already reported
       set SpecRawData [second $m]

       for {set i 1} {$i<=$numtag} {incr i} {
          if {$tagx($i) != 0} {set tagy($i) [lindex $SpecRawData $tagx($i)]}
       }

       set SpecPathName [load_spectrum [SpectrumName]]

   }

   proc do_click {} {
       variable cgidata
       variable Started
       variable LogFlag
       variable ShowLogFlag
       variable JS
       variable SpecName
       variable DirName
       variable SearchName
       variable SpecDim
       variable MemSas
       variable DiscSas
       variable Skip0
       variable XMin
       variable XMax
       variable YMin
       variable YMax
       variable activegallery
       variable Showing
       variable SpecShow
       
       set SearchName 0

       set cgidata [ncgi::nvlist]

       if {$LogFlag == 1} {InsertLog "cgidata= ([llength $cgidata]) $cgidata"}

       if {[llength $cgidata] == 0} then {return}

       if {[llength $cgidata] < 2} then {
           InsertLog "CGI data is too short: $cgidata"
       } else {
           if {[lindex $cgidata 0] != "Widget"} then {
               InsertLog "Invalid CGI data: $cgidata"
           } else {

               set w [lindex $cgidata 1]
               set vl [second [lindex $cgidata 1]]

               set showit $Showing
               set Showing 0

               switch -glob [lindex $w 0] {

                   RESET    {set Started 0; return}
                   CLEAR    {EmptyLog}
                   ELOG     {PrintLog}
                   RELOAD   {variable Reloading; set Reloading 1}
                   VARIABLES {show_variables}

                   HIDE     {set ShowLogFlag 0}
                   SHOW     {set ShowLogFlag 1}
                   LOGON    {set LogFlag 1}
                   LOGOFF   {set LogFlag 0}

                   SERVER     {set ::DataAcquisition::ACQSERVER $vl; set SpecShow 0; set showit 0}
                   ALLSERVERS {set allservers [expr ($allservers + 1) & 1]}

                   SPECSHOW {
                       switch [lindex $w 1] {
                          0   {do_loadSpectrum}        ;# LOAD
                          1   {do_updateSpectrum; do_show}      ;# UPDATE
                          2   {do_show}                ;# SHOW
                       }
                   }
                   
                   SPECCONT {do_cont [lindex $w 1]}

                   SPECNAMES -
                   SPECNAME {set SpecName [lindex $w 1]; set SearchName 1; do_reset; do_loadSpectrum; do_show}
                   
                   DIRNAMES -
                   DIRNAME {
                       set DirName [lindex $w 1]
                       if {$MemSas == 1}  {do_inquiry *}
                       if {$DiscSas == 1} {do_inquiry [file join $DirName *]}
                       set SearchName 1
                   }

                   XMIN     {set XMin [lindex $w 1]}
                   XMAX     {set XMax [lindex $w 1]}
                   YMIN     {set YMin [lindex $w 1]}
                   YMAX     {set YMax [lindex $w 1]}
                   
                   GALLERIES {variable numgallery; set numgallery [lindex $w 1]}
                   GALLERY  {set activegallery [lindex $w 1]; do_pushtag [lindex $w 2]}
                   EXPAND   {set activegallery [lindex $w 1]; do_pushtag [lindex $w 2]; do_pushtag [lindex $w 3]; do_expand}
                   VIEW     {do_view $w}
                   ARRANGE  {do_arrange $w}
                   ANALYSIS {do_analysis $w}
                   TAGSFITS {do_tagsfits $w}
                   ACTIONS1 {do_actions1 $w}
                   ACTIONS2 {do_actions2 $w}
                   
                   MainLog {}
                   undefined {}
                   default {InsertLog "unexpected CGI data: [lindex $w 0]: $cgidata"; set showit 0}
               }
           }
       }
       if {$showit} {do_show}
    }
    
    if {$MemSas == 1}  {do_inquiry *}
    if {$DiscSas == 1} {do_inquiry [file join $DirName *]}
    set html ""

}   ;# end of if {$Started == 0}



