


#variable Started 0

if {![info exists Started]} {variable Started 0}

if {$Started != 0} {

     variable JS ""
     variable LogFlag

     if {$LogFlag == 1} {InsertLog "Last Updated: [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"}

    do_click
    
    if {$Reloading == 1} {
        set Reloading 0
        set z [catch {source analysis.tcl} m]
        if {$z != 0} {puts "analysis.tcl returned z=$z and $m"}
    }

}

if {$Started == 0} {           ;#  first time load code and define local variables

#    global MIDAS_SpectrumAccessServer_Exists
#    if {![info exists MIDAS_SpectrumAccessServer_Exists]} then {

       set z [catch {package require SpectrumClient} m]
       if {$z != 0} {puts "SpectrumClient returned z=$z and $m"}
#    }

     set z [catch {source analysis.tcl} m]
     if {$z != 0} {puts "analysis.tcl returned z=$z and $m"}

    set Started 1

    variable LogText ""
    variable LogFlag 0
    variable LogCount 0

    variable ShowLogFlag 0

    variable JS ""

    variable MemSas 0
    variable DiscSas 0
    global MemSasAccess_Exists
    if {[info exists MemSasAccess_Exists]}  {set MemSas 1}
    global DiscSasAccess_Exists
    if {[info exists DiscSasAccess_Exists]} {set DiscSas 1}

    if {$MemSas == 0 && $DiscSas == 0} {set MemSas 1}
    
    if {$DiscSas == 1} {
        namespace eval ::DataAcquisition {variable ACQSERVERS; set ACQSERVERS [list localhost]; variable ACQSERVER; set ACQSERVER [lindex $ACQSERVERS 0]}
    }
    
    global tcl_platform
    if {$tcl_platform(platform) == "unix"} {
        variable DirName "/MIDAS/Samples/spectra"
    } else {
        variable DirName "c:/MIDAS/Samples/spectra"
    }
    
    variable numgallery 1
    variable activegallery 1
    
    variable numtag 10
    variable tagx
    variable tagy
    for {set i 1} {$i<=$numtag} {incr i} {set tagx($i) 0; set tagy($i) 0}
    variable ntags 0
    
    variable Colors
    set Colors(1) rgb(0,0,255)   ;# blue
    set Colors(2) rgb(0,255,0)   ;# lime green
    set Colors(3) rgb(255,165,0) ;# orange
    set Colors(4) rgb(255,0,255) ;# magenta
    set Colors(5) rgb(0,255,255) ;# cyan
    set Colors(6) rgb(255,255,0) ;# yellow
    set Colors(7) rgb(128,0,128)   ;# purple
    set Colors(8) rgb(255,192,203)   ;# pink
    set Colors(9) rgb(128,128,0) ;# olive
    set Colors(10) rgb(0,128,128) ;# darn green
    
    set Colors(ActiveGallery) rgb(0,0,0)   ;# black
    set Colors(InActiveGallery) rgb(128,128,128)   ;# black
    set Colors(Crosshair) rgb(0,0,0)   ;# black
    set Colors(11)  rgb(255,0,0)  ;# red
    
    proc show_variables {} {
        variable LogFlag
        variable LogCount
        variable ShowLogFlag
        variable MemSas
        variable DiscSas
        variable SpecName
        variable DirName
        variable SpecTitle
        
       variable XMin
       variable XMax
       variable YMin
       variable YMax
       variable SpecSize
       variable SpecLimit
       variable WindowSize
        
       global MIDAS_SpectrumAccessServer_Exists
       global SpectrumServerHost

       InsertLog "AcqServers=$::DataAcquisition::ACQSERVERS"
       InsertLog "AcqServer=$::DataAcquisition::ACQSERVER"

         InsertLog "LogFlag=$LogFlag; LogCount=$LogCount; ShowLogFlag=$ShowLogFlag"
         InsertLog "MemSas=$MemSas; DiscSas=$DiscSas"
         InsertLog "DirName=$DirName; SpecName=$SpecName"
         InsertLog "Spectrum=[SpectrumName]"
         InsertLog "SpecTitle=$SpecTitle"
         
         InsertLog "$XMin $XMax $YMin $YMax $SpecSize $WindowSize $SpecLimit"

       if {[info exists MIDAS_SpectrumAccessServer_Exists]} then {
         InsertLog "MIDAS_SpectrumAccessServer_Exists = $MIDAS_SpectrumAccessServer_Exists"
       }

       if {[info exists SpectrumServerHost]} then {
         InsertLog "SpectrumServerHost = $SpectrumServerHost"
       }
    }
    
    proc SpectrumName {} {
        variable MemSas
        variable DiscSas
        variable DirName
        variable SpecName
        if {$MemSas == 1} {return $SpecName}
        if {$DiscSas == 1} {return [file join $DirName $SpecName]}
    }

   proc do_create2D {} {
       variable SpecB
       variable SpecR
       variable SpecArgs
       global errorCode errorInfo
       
       global MIDAS_SpectrumAccessServer_Exists
       global SpectrumServerHost

       if {[info exists MIDAS_SpectrumAccessServer_Exists] && $MIDAS_SpectrumAccessServer_Exists == 1} then {
           set rc [catch {interp eval "" ::namespace inscope ::urn:SpectrumService  SpecNew  [SpectrumName] "$SpecB" "$SpecR" "$SpecArgs"} msg]
           set m [lindex $msg 5]
       } else {
           if {$SpectrumServerHost != $::DataAcquisition::ACQSERVER} {
                set SpectrumServerHost  $::DataAcquisition::ACQSERVER
                SpectrumClient_Configure
           }
           set rc [catch {SpectrumClient__Create2DSpectrum [SpectrumName] "$SpecB" "$SpecR" "$SpecArgs"} msg]
           set m $msg
       }

       if {$rc == 0} {
           InsertLog "SpecNew returned: $m"
       } else {
           InsertLog "SpecNew returned with an error\n$msg\n$errorCode\n$errorInfo"
       }
   }

   proc do_create1D {} {
       variable SpecB
       variable SpecR
       global errorCode errorInfo
       
       global MIDAS_SpectrumAccessServer_Exists
       global SpectrumServerHost

       if {[info exists MIDAS_SpectrumAccessServer_Exists] && $MIDAS_SpectrumAccessServer_Exists == 1} then {
           set rc [catch {interp eval "" ::namespace inscope ::urn:SpectrumService  SpecNew  [SpectrumName] "$SpecB" "$SpecR"} msg]
           set m [lindex $msg 5]
       } else {
           if {$SpectrumServerHost != $::DataAcquisition::ACQSERVER} {
                set SpectrumServerHost  $::DataAcquisition::ACQSERVER
                SpectrumClient_Configure
           }
           set rc [catch {SpectrumClient__Create1DSpectrum [SpectrumName] "$SpecB" "$SpecR"} msg]
           set m $msg
       }

       if {$rc == 0} {
           InsertLog "SpecNew returned: $m"
       } else {
           InsertLog "SpecNew returned with an error\n$msg\n$errorCode\n$errorInfo"
       }
   }

   proc do_inquiry {name} {
       global errorCode errorInfo
       variable SpectrumList

       global MIDAS_SpectrumAccessServer_Exists
       global SpectrumServerHost

       if {[info exists MIDAS_SpectrumAccessServer_Exists] && $MIDAS_SpectrumAccessServer_Exists == 1} then {
           set rc [catch {interp eval "" ::namespace inscope ::urn:SpectrumService SpecNames $name} msg]
           set m [lindex $msg 5]
       } else {
           if {$SpectrumServerHost != $::DataAcquisition::ACQSERVER} {
                set SpectrumServerHost  $::DataAcquisition::ACQSERVER
                SpectrumClient_Configure
           }
           set rc [catch {SpectrumClient__InquireSpectra $name} msg]
           set m $msg
       }

       if {$rc == 0} {
#           InsertLog "SpecNames returned: $msg"
           set SpectrumList {}
           foreach item $m {lappend SpectrumList $item}
           set SpectrumList [lsort -dictionary $SpectrumList]
       } else {
           InsertLog "SpecNames returned with an error\n$msg\n$errorCode\n$errorInfo"
       }
   }

   proc do_details {opt} {
       global errorCode errorInfo
       
       global MIDAS_SpectrumAccessServer_Exists
       global SpectrumServerHost

       if {[info exists MIDAS_SpectrumAccessServer_Exists] && $MIDAS_SpectrumAccessServer_Exists == 1} then {
           set rc [catch {interp eval "" ::namespace inscope ::urn:SpectrumService SpecDetails [SpectrumName]} msg]
           set m [lindex $msg 5]
       } else {
           if {$SpectrumServerHost != $::DataAcquisition::ACQSERVER} {
                set SpectrumServerHost  $::DataAcquisition::ACQSERVER
                SpectrumClient_Configure
           }
           set rc [catch {SpectrumClient__SpectrumDetails [SpectrumName]} msg]
           set m $msg
       }

       if {$rc == 0} {
          if {$opt == 0} {
             InsertLog "SpecDetails returned:"
             foreach item $m {InsertLog "$item"}
          }
       } else {
           InsertLog "SpecDetails returned with an error\n$msg\n$errorCode\n$errorInfo"
       }
       
       return [list $rc $m]
   }

   proc do_title {opt} {
       global errorCode errorInfo
       variable DataList
       
       global MIDAS_SpectrumAccessServer_Exists
       global SpectrumServerHost

       if {[info exists MIDAS_SpectrumAccessServer_Exists] && $MIDAS_SpectrumAccessServer_Exists == 1} then {
           set rc [catch {interp eval "" ::namespace inscope ::urn:SpectrumService SpecGetTitle [SpectrumName]} msg]
           set m [lindex $msg 5]
       } else {
           if {$SpectrumServerHost != $::DataAcquisition::ACQSERVER} {
                set SpectrumServerHost  $::DataAcquisition::ACQSERVER
                SpectrumClient_Configure
           }
           set rc [catch {SpectrumClient__SpectrumGetTitle [SpectrumName]} msg]
           set m $msg
       }

       if {$rc == 0} {
          if {$opt == 0} {
            InsertLog "SpecGetTitle returned: $m"
          }
          set DataList $m
       } else {
           InsertLog "SpecGetTitle returned with an error\n$msg\n$errorCode\n$errorInfo"
       }
       
       return [list $rc $m]
   }

   proc do_read1D {Name Base Range Compression} {
       global errorCode errorInfo
       
       global MIDAS_SpectrumAccessServer_Exists
       global SpectrumServerHost

       if {[info exists MIDAS_SpectrumAccessServer_Exists] && $MIDAS_SpectrumAccessServer_Exists == 1} then {
           set rc [catch {interp eval "" ::namespace inscope ::urn:SpectrumService SpecRead1DText $Name $Base $Range $Compression} msg]
           set m [lindex $msg 5]
       } else {
           if {$SpectrumServerHost != $::DataAcquisition::ACQSERVER} {
                set SpectrumServerHost  $::DataAcquisition::ACQSERVER
                SpectrumClient_Configure
           }
           set rc [catch {SpectrumClient__Read1DSpectrumText $Name $Base $Range $Compression} msg]
           set m $msg
       }

       if {$rc == 0} {
#           InsertLog "SpecRead1DText returned:"
#           foreach item $m {InsertLog "$item"}
       } else {
           InsertLog "SpecRead1DText returned with an error\n$msg\n$errorCode\n$errorInfo"
       }
       
       return [list $rc $m]    
   }
   
   proc do_read2D {Base0 Range0 Base1 Range1 Compression0 Compression1} {
       global errorCode errorInfo
       
       global MIDAS_SpectrumAccessServer_Exists
       global SpectrumServerHost

       if {[info exists MIDAS_SpectrumAccessServer_Exists] && $MIDAS_SpectrumAccessServer_Exists == 1} then {
           set rc [catch {interp eval "" ::namespace inscope ::urn:SpectrumService SpecRead2DText [SpectrumName] $Base0 $Range0 $Base1 $Range1 $Compression0 $Compression1} msg]
           set m [lindex $msg 5]
       } else {
           if {$SpectrumServerHost != $::DataAcquisition::ACQSERVER} {
                set SpectrumServerHost  $::DataAcquisition::ACQSERVER
                SpectrumClient_Configure
           }
           set rc [catch {SpectrumClient__Read2DSpectrumText [SpectrumName] $b $r} msg]
           set m $msg
       }

       if {$rc == 0} {
#           InsertLog "SpecRead2DText returned:"
#           foreach item $m {InsertLog "$item"}
       } else {
           InsertLog "SpecRead2DText returned with an error\n$msg\n$errorCode\n$errorInfo"
       }
       
       return [list $rc $m]    
   }
   
   proc do_delete {} {
       global errorCode errorInfo
       
       global MIDAS_SpectrumAccessServer_Exists
       global SpectrumServerHost

       if {[info exists MIDAS_SpectrumAccessServer_Exists] && $MIDAS_SpectrumAccessServer_Exists == 1} then {
           set rc [catch {interp eval "" ::namespace inscope ::urn:SpectrumService SpecDelete [SpectrumName]} msg]
           set m [lindex $msg 5]
       } else {
           if {$SpectrumServerHost != $::DataAcquisition::ACQSERVER} {
                set SpectrumServerHost  $::DataAcquisition::ACQSERVER
                SpectrumClient_Configure
           }
           set rc [catch {SpectrumClient__DeleteSpectrum [SpectrumName]} msg]
           set m $msg
       }

       if {$rc == 0} {
           InsertLog "SpecDelete returned: $m"
       } else {
           InsertLog "SpecDelete returned with an error\n$msg\n$errorCode\n$errorInfo"
       }
   }

   proc do_zero {} {
       global errorCode errorInfo
       
       global MIDAS_SpectrumAccessServer_Exists
       global SpectrumServerHost

       if {[info exists MIDAS_SpectrumAccessServer_Exists] && $MIDAS_SpectrumAccessServer_Exists == 1} then {
           set rc [catch {interp eval "" ::namespace inscope ::urn:SpectrumService SpecZero [SpectrumName]} msg]
           set m [lindex $msg 5]
       } else {
           if {$SpectrumServerHost != $::DataAcquisition::ACQSERVER} {
                set SpectrumServerHost  $::DataAcquisition::ACQSERVER
                SpectrumClient_Configure
           }
           set rc [catch {SpectrumClient__ZeroSpectrum [SpectrumName]} msg]
           set m $msg
       }

       if {$rc == 0} {
           InsertLog "SpecZero returned: $m"
       } else {
           InsertLog "SpecZero returned with an error\n$msg\n$errorCode\n$errorInfo"
       }
   }

   proc do_show_2d {args} {
       variable SpecName
       variable SpecTitle
       variable SpecData
       variable SpecCont
       variable SpecLength
       variable SpecShow
       variable SpecBase0
       variable SpecRange0
       variable SpecBase1
       variable SpecRange1
       variable Skip0
       variable XMin
       variable XMax
       variable CanvasX
       variable CanvasY
       variable Showing

       set m [do_details 1]
       if {[first $m] != 0} {return}    ;#   error already reported
       set details [second $m]
       
           set SpecBase0 [first [second $details]]
           set SpecBase1 [second [second $details]]
           set SpecRange0 [first [third $details]]
           set SpecRange1 [second [third $details]]
           
       set m [do_title 1]
       if {[first $m] != 0} {return}    ;#   error already reported
       set SpecTitle [second $m]
       
           if {$SpecTitle == ""} {set SpecTitle $SpecName} {set SpecTitle "$SpecTitle ($SpecName)"}

       set canvaswidth 512

       set xscale [expr $canvaswidth / $SpecRange0]
       set yscale [expr $canvaswidth / $SpecRange1]
       if {$canvaswidth > $SpecRange0 && $canvaswidth > $SpecRange1} {
          set xscale [expr max(1, int(((10.0 * $xscale)+5.0)/10.0))]
          set yscale [expr max(1, int(((10.0 * $yscale)+5.0)/10.0))]
       }
       set xscale [expr min($xscale, $yscale)]
       set yscale [expr min($xscale, $yscale)]
       set cx [expr int($SpecRange0*$xscale)]
       if {!$cx} {set cx $canvaswidth}
       set cy [expr int($SpecRange1*$yscale)]
       if {!$cy} {set cy $canvaswidth}

#       set val [expr $SpecRange0 / $cx]
       set val [expr max(1, ($SpecRange0 / $cx))]
       set Cmp0 $val;
#       set val [expr $SpecRange1 / $cy]
#       set val [expr max(1, $val)]
       set val [expr max(1, ($SpecRange1 / $cy))]
       set CanvasX $cx; set CanvasY $cy;
       set Cmp1 $val;
       set Compression [expr max($Cmp0, $Cmp1)];

#       set Compression [expr max(1, $SpecRange0 / 512)]
#       set Compression [expr max($Compression, $SpecRange1 / 512)]
#       InsertLog "Using $Compression Compression"

       set m [do_read2D $SpecBase0 $SpecRange0 $SpecBase1 $SpecRange1 $Compression $Compression]
       if {[first $m] != 0} {return}    ;#   error alread reported
       set data [second $m]
       
           set SpecData ""
           set SpecLength [llength $data]
           
           set comp0 [expr $SpecRange0 / $Compression]
           set comp1 [expr $SpecRange1 / $Compression]
           set SpecLength0 [expr $SpecLength / $comp1]
           set SpecLength1 [expr $SpecLength / $comp0]
           set DataLength0 [expr min($comp0, $SpecLength0)]
           set DataLength1 [expr min($comp1, $SpecLength1)]

           set zmin 0; set zmax 0;
           for {set i 0; set c $SpecBase0; set bc 0} {$c < [expr $SpecBase0 + int($SpecRange0/$Cmp1)]} {incr i; incr c} {
              for {set j 0; set x 0} {$x < [expr int($SpecRange1/$Cmp0)-1]} {incr j; incr x} {
                set item [lindex $data $bc]
                if {$item < $zmin} {set zmin $item}
                if {$item > $zmax} {set zmax $item}
                append SpecData "\[[expr $i],[expr $j],$item\], "
                incr bc
              }
              set item [lindex $data $bc]
              if {$item < $zmin} {set zmin $item}
              if {$item > $zmax} {set zmax $item}
              if {[expr $c+1] >= [expr $SpecBase0 + int($SpecRange0/$Cmp1)]} {
                append SpecData "\[[expr $i],[expr $j],$item\]"
              } else {
                append SpecData "\[[expr $i],[expr $j],$item\], "
              }
              incr bc
           }
           set step  [expr ((abs(int(($zmax - $zmin)) + 1) / 31))]
           if {$step < 1} {set step 1}
           set SpecCont ""
           for {set i 0} {$i<30} {incr i} {
             append SpecCont "[expr $zmin + $step * $i], "
           }
           append SpecCont "[expr $zmin + $step * $i]"

       set SpecShow 2
       set Showing 2
   }

   proc do_show_1d {args} {
       variable SpecName
       variable SpecRawData
       variable Compression
       variable SpecTitle
       variable SpecData
       variable SpecLength
       variable SpecShow
       variable SpecBase
       variable SpecSize
       variable SpecLimit
       variable WindowSize
       variable SpecRange
       variable Skip0
       variable XMin
       variable XMax
       variable YMin
       variable YMax
       variable Showing

       set m [do_details 1]
       if {[first $m] != 0} {return}    ;#   error already reported
       set details [second $m]
       
           set SpecDim [first $details]
           if {$SpecDim == 2} {do_show2d; return}
           if {$SpecDim != 1} {InsertLog "Spectrum Dimension is $SpecDim; only 1d & 2d supported"; return}
           set SpecBase [second $details]
           set SpecSize [third $details]
           if {$XMin < $SpecBase} {set XMin $SpecBase}
           if {$XMax < $SpecBase} {set XMax $SpecSize}
           if {$XMax >= $SpecSize} {set XMax [expr $SpecSize - 1]}
           if {$XMin > $XMax} {set XMin $SpecBase}
           if {$XMin == $SpecBase && $Skip0} {set XMin [expr $SpecBase + 1]}
           set SpecRange [expr $XMax - $XMin + 1]
           set WindowSize [expr $XMax - $XMin + 1]
           
       set m [do_title 1]
       if {[first $m] != 0} {return}    ;#   error already reported
       set SpecTitle [second $m]
              
#       if {$SpecTitle == ""} {set SpecTitle $SpecName} {set SpecTitle "$SpecTitle ($SpecName)"}

       set Compression [expr max(1, $SpecRange / 1024)]
#       InsertLog "Using $Compression Compression"

       set m [do_read1D [SpectrumName] $XMin $SpecRange $Compression]
       if {[first $m] != 0} {return}    ;#   error already reported
       set SpecRawData [second $m]
       
           set SpecData ""
           set SpecLength [llength $SpecRawData]
           set SpecLimit 0
           for {set i 0} {$i < $SpecLength} {incr i} {
               set item [lindex $SpecRawData $i]
               if {$item > $SpecLimit} {set SpecLimit $item}
           }
#           set YMin 0; set YMax [expr ($SpecLimit * 11)/10]
           
           set comp [expr $SpecRange / $Compression]
           set DataLength [expr min($comp, $SpecLength)]
           set leng $DataLength
           set j $XMin
           for {set i 0} {$i < $leng} {incr i} {
             set item [lindex $SpecRawData $i]
             append SpecData "\[[expr $j],$item\],"
             incr j $Compression
           }
#           set item [lindex $SpecRawData $i]
#           append SpecData "\[[expr $j],0\]"
           set SpecShow 1

       set Showing 1
   }

   proc do_show {} {
       
       set m [do_details 1]
       if {[first $m] != 0} {return}    ;#   error alread reported
       set details [second $m]
       
           set dim [first $details]
           if {$dim == 1} {do_show_1d; return}
           if {$dim == 2} {do_show_2d; return}
           
           InsertLog "Spectrum Dimension is $dim; only 1d & 2d supported"
   }

   proc do_click {} {
       variable cgidata
       variable Started
       variable LogFlag
       variable ShowLogFlag
       variable JS
       variable SpecName
       variable DirName
       variable SearchName
       variable SpecDim
       variable MemSas
       variable DiscSas
       variable Skip0
       variable XMin
       variable XMax
       variable YMin
       variable YMax
       variable activegallery
       variable Showing
       
       set SearchName 0

       set cgidata [ncgi::nvlist]

       if {$LogFlag == 1} {InsertLog "cgidata= ([llength $cgidata]) $cgidata"}

       if {[llength $cgidata] == 0} then {return}

       if {[llength $cgidata] < 2} then {
           InsertLog "CGI data is too short: $cgidata"
       } else {
           if {[lindex $cgidata 0] != "Widget"} then {
               InsertLog "Invalid CGI data: $cgidata"
           } else {

               set w [lindex $cgidata 1]
               set vl [second [lindex $cgidata 1]]

               set showit $Showing
               set Showing 0

               switch -glob [lindex $w 0] {

                   RESET    {set Started 0; return}
                   CLEAR    {EmptyLog}
                   ELOG     {PrintLog}
                   RELOAD   {variable Reloading; set Reloading 1}
                   VARIABLES {show_variables}

                   HIDE     {set ShowLogFlag 0}
                   SHOW     {set ShowLogFlag 1}
                   LOGON    {set LogFlag 1}
                   LOGOFF   {set LogFlag 0}

                   SERVER     {set ::DataAcquisition::ACQSERVER $vl}
                   ALLSERVERS {set allservers [expr ($allservers + 1) & 1]}

                   SPECSHOW {
                       switch [lindex $w 1] {
                          0   {do_reset; do_show; set showit 0}
                          1   {do_show; set showit 0}
                       }
                   }
                   
                   SPECCONT {do_cont [lindex $w 1]}

                   SPECNAMES -
                   SPECNAME {set SpecName [lindex $w 1]; set SearchName 1; set showit 1}
                   
                   DIRNAMES -
                   DIRNAME {
                       set DirName [lindex $w 1]
                       if {$MemSas == 1}  {do_inquiry *}
                       if {$DiscSas == 1} {do_inquiry [file join $DirName *]}
                       set SearchName 1
                       set showit 0
                   }

                   XMIN     {set XMin [lindex $w 1]}
                   XMAX     {set XMax [lindex $w 1]}
                   YMIN     {set YMin [lindex $w 1]}
                   YMAX     {set YMax [lindex $w 1]}
                   
                   GALLERIES {variable numgallery; set numgallery [lindex $w 1]}
                   GALLERY  {set activegallery [lindex $w 1]; do_pushtag [lindex $w 2]}
                   EXPAND   {set activegallery [lindex $w 1]; do_pushtag [lindex $w 2]; do_pushtag [lindex $w 3]; do_expand}
                   VIEW     {do_view $w}
                   ARRANGE  {do_arrange $w}
                   ANALYSIS {do_analysis $w}
                   TAGSFITS {do_tagsfits $w}
                   ACTIONS1 {do_actions1 $w}
                   ACTIONS2 {do_actions2 $w}
                   
                   MainLog {}
                   undefined {}
                   default {InsertLog "unexpected CGI data: [lindex $w 0]: $cgidata"; set showit 0}
               }
           }
       }
       if {$showit} {do_show}
    }
    
    if {$MemSas == 1}  {do_inquiry *}
    if {$DiscSas == 1} {do_inquiry [file join $DirName *]}
    set html ""

}   ;# end of if {$Started == 0}



