
#    MIDAS Access Server  for  PGRIS 


package require MIDASDomainHandler     ;#  load default support procedures

 set z [catch {package require PGRISAccess} m]
 if {$z != 0} {puts $m}

global MIDAS_PGRISAccessServer_Exists
set MIDAS_PGRISAccessServer_Exists 0

global MIDAS_PGRISAccessServer_Verbose
set MIDAS_PGRISAccessServer_Verbose 0

# Use namespaces to isolate our methods
namespace eval urn:PGRISAccessServer {

    proc AccessServerVerbose {option} {
        do_AccessServerVerbose $option
        return [rpcvar::rpcvar int 0]
    }

    proc Set {Address Value} {
        do_Set $Address $Value
        return [rpcvar::rpcvar int 0]
    }

    proc SetBitRegister {Address Value} {
        do_SetBitRegister $Address $Value
        return [rpcvar::rpcvar int 0]
    }

    proc Get {Address} {
        set vl [do_Get $Address]
        return [rpcvar::rpcvar int $vl]
    }

    proc do_AccessServerVerbose {option} {
        global MIDAS_PGRISAccessServer_Verbose
        if {$MIDAS_PGRISAccessServer_Verbose} {puts "called method AccessServerVerbose with parameter $option"}
        set MIDAS_PGRISAccessServer_Verbose $option
        PGRISAccess_Verbose $option
    }

    proc do_Set {Address Value} {
       global MIDAS_PGRISAccessServer_Verbose

       if {$MIDAS_PGRISAccessServer_Verbose} {puts "do_Set $Address ([format "0x%x" $Address]) = $Value"}

       set z [catch {PGRISAccess_Set -a $Address -d $Value} m]
       if {$z == 0} then {
          return 0
       } else {
           return -code error -errorcode 0x10005 -errorinfo "received error response: rc=$z\n  $m"
       }
    }

    proc do_SetBitRegister {Address Value} {
       global MIDAS_PGRISAccessServer_Verbose

       set bits [split $Value]

       set l 0

       foreach bit $bits {
           if {[string length $bit] == 0} {continue}
           do_Set $Address $bit           ;#  write channel data bit
           do_Set [expr $Address + 2] 1   ;#  set clock
           do_Set [expr $Address + 2] 0   ;#  clear clock
           incr l
       }

       if {$MIDAS_PGRISAccessServer_Verbose} {puts "do_SetBitRegister $Address depth $l"}

       return 0
    }

    proc do_Get {Address} {
       global MIDAS_PGRISAccessServer_Verbose

       set z [catch {PGRISAccess_Get -a $Address} m]
       if {$z == 0} then {
          if {$MIDAS_PGRISAccessServer_Verbose} {puts "do_Get $Address ([format "0x%x" $Address]) = $m"}
          return $m
       } else {
           if {$MIDAS_PGRISAccessServer_Verbose} {puts "do_Get $Address ([format "0x%x" $Address])"}
           return -code error -errorcode 0x10005 -errorinfo "received error response: rc=$z\n  $m"
       }
    }


    # We have to publish the public methods...

     SOAP::export AccessServerVerbose
     SOAP::export Set
     SOAP::export Get
}

# register this service with tclhttpd
puts [SOAP::Domain::register  -prefix  /PGRISAccessServer -namespace urn:PGRISAccessServer -uri urn:PGRISAccessServer]


proc ::SOAP::Domain::MIDAS_SOAPDomainHandler_/PGRISAccessServer {optsname sock args} {   \
    ::SOAP::Domain::MIDAS_SOAPDomainHandler_/DefaultAccessServer $optsname $sock $args}

package provide PGRISAccessServer 1.0
