

#   Run Control Server Implementation file 


    package require DataAcquisitionControlServer   ;# load generic code

global MIDAS_DataAcquisitionControlServer_Verbose
set MIDAS_DataAcquisitionControlServer_Verbose 0


namespace eval urn:DataAcquisitionControlServer {

# do what's needed to setup all hardware
proc do_Implementation-SetUp {args} {
       global MIDAS_DataAcquisitionCode MIDAS_DataAcquisitionState MIDAS_DataAcquisitionReason
       global MIDAS_DataAcquisitionError MIDAS_DataAcquisitionInfo

     global MIDAS_DataAcquisitionControlServer_Verbose;
     if {$MIDAS_DataAcquisitionControlServer_Verbose} {puts "Entered do_Implementation-SetUp with args $args"}

        set z [catch {Appdo_Setup $args} m]    ;#  sys do_Setup
        if {$MIDAS_DataAcquisitionControlServer_Verbose} {puts "do_SetUp returned z=$z and $m"}

        if {$z != 0} {

            if {[info procs ::DefineMessage] == "::DefineMessage"} {
               ::DefineMessage -c AcqControl -l INFORMATION  "SETUP returned with an error\n$m"
            } 

            puts "SETUP returned with an error\n$m"

            set MIDAS_DataAcquisitionCode 6
        } else {

            if {[info procs ::DefineMessage] == "::DefineMessage"} {
               ::DefineMessage -c AcqControl -l INFORMATION  "SETUP returned $m"
            } 
#            set MIDAS_DataAcquisitionCode 0   -  state set by SYS application
        }
}

# do what's needed to reset all hardware
proc do_Implementation-Reset {args} {
     global MIDAS_DataAcquisitionCode

     global MIDAS_DataAcquisitionControlServer_Verbose;
     if {$MIDAS_DataAcquisitionControlServer_Verbose} {puts "Entered do_Implementation-Reset with args $args"}

     set z [catch {Appdo_Reset $args} m]    ;#   sys do_Reset
     if {$MIDAS_DataAcquisitionControlServer_Verbose} {puts "do_Reset returned z=$z and $m"}

       if {$z != 0} {

            if {[info procs ::DefineMessage] == "::DefineMessage"} {
               ::DefineMessage -c AcqControl -l INFORMATION  "RESET returned with an error\n$m"
            } 

            puts "RESET returned with an error\n$m"

            set MIDAS_DataAcquisitionCode 6
        } else {

            if {[info procs ::DefineMessage] == "::DefineMessage"} {
               ::DefineMessage -c AcqControl -l INFORMATION  "RESET returned $m"
            } 
#            set MIDAS_DataAcquisitionCode 0   -  state set by SYS application
        }
}

# do what's needed to stop all "going" hardware streams
proc do_Implementation-Stop {args} {
     global MIDAS_DataAcquisitionCode

     global MIDAS_DataAcquisitionControlServer_Verbose;
     if {$MIDAS_DataAcquisitionControlServer_Verbose} {puts "Entered do_Implementation-Stop with args $args"}

     set z [catch {Appdo_Stop $args} m]     ;#   sys do_Stop
     if {$MIDAS_DataAcquisitionControlServer_Verbose} {puts "do_Stop returned z=$z and $m"}

       if {$z != 0} {

            if {[info procs ::DefineMessage] == "::DefineMessage"} {
               ::DefineMessage -c AcqControl -l INFORMATION  "STOP returned with an error\n$m"
            } 

            puts "STOP returned with an error\n$m"

            set MIDAS_DataAcquisitionCode 6
        } else {

            if {[info procs ::DefineMessage] == "::DefineMessage"} {
               ::DefineMessage -c AcqControl -l INFORMATION  "STOP returned $m"
            } 
#            set MIDAS_DataAcquisitionCode 0   -  state set by SYS application
        }
}

# do what's needed to start all halted hardware streams
proc do_Implementation-Go {args} {
     global MIDAS_DataAcquisitionCode

     global MIDAS_DataAcquisitionControlServer_Verbose;
     if {$MIDAS_DataAcquisitionControlServer_Verbose} {puts "Entered do_Implementation-Go with args $args"}

     set z [catch {Appdo_Go $args} m]          ;#   sys   do_Go
     if {$MIDAS_DataAcquisitionControlServer_Verbose} {puts "do_Go returned z=$z and $m"}

       if {$z != 0} {

            if {[info procs ::DefineMessage] == "::DefineMessage"} {
               ::DefineMessage -c AcqControl -l INFORMATION  "GO returned with an error\n$m"
            } 

            puts "GO returned with an error\n$m"

            set MIDAS_DataAcquisitionCode 6
        } else {

            if {[info procs ::DefineMessage] == "::DefineMessage"} {
               ::DefineMessage -c AcqControl -l INFORMATION  "GO returned $m"
            } 
#            set MIDAS_DataAcquisitionCode 0   -  state set by SYS application
        }
}

# do what's needed to set Data Acq program control options
proc do_Implementation-SetOption {args} {
     global MIDAS_DataAcquisitionCode

     global MIDAS_DataAcquisitionControlServer_Verbose;
     if {$MIDAS_DataAcquisitionControlServer_Verbose} {puts "Entered do_Implementation-SetOption with args $args"}

     set z [catch {Appdo_SetOption $args} m]      ;#    sys do_SetOption
     if {$MIDAS_DataAcquisitionControlServer_Verbose} {puts "do_SetOption returned z=$z and $m"}
}

# do what's needed to get Data Acq program control options
proc do_Implementation-GetOption {args} {
     global MIDAS_DataAcquisitionOption

     global MIDAS_DataAcquisitionControlServer_Verbose;
     if {$MIDAS_DataAcquisitionControlServer_Verbose} {puts "Entered do_Implementation-GetOption with args $args"}

     set z [catch {Appdo_GetOption $args} m]      ;#    sys   do_GetOption
     if {$MIDAS_DataAcquisitionControlServer_Verbose} {puts "do_GetOption returned z=$z and $m"}

     return $m
}

proc do_Implementation-Counters {option} {
       global MIDAS_DataAcquisitionCounters

     global MIDAS_DataAcquisitionControlServer_Verbose;
     if {$MIDAS_DataAcquisitionControlServer_Verbose} {puts "Entered do_Implementation-Counters"}

     set z [catch {Appdo_GetCounters $option} m]     ;#     stats    do_GetCounters
     if {$MIDAS_DataAcquisitionControlServer_Verbose} {puts "do_GetCounters returned z=$z"}

     return $m
}

proc do_Implementation-Rates {option} {
       global MIDAS_DataAcquisitionRates

     global MIDAS_DataAcquisitionControlServer_Verbose;
     if {$MIDAS_DataAcquisitionControlServer_Verbose} {puts "Entered do_Implementation-Rates"}

     set z [catch {Appdo_GetRates $option} m]       ;#   stats     do_GetRates
     if {$MIDAS_DataAcquisitionControlServer_Verbose} {puts "do_GetRates returned z=$z"}

     return $m
}

proc do_Implementation-GetState {} {
     global env
     global MIDAS_DataAcquisitionCode

     global MIDAS_DataAcquisitionControlServer_Verbose;
     if {$MIDAS_DataAcquisitionControlServer_Verbose} {puts "Entered do_Implementation-GetState"}

# puts "do_Implementation-Get_State DataAcquisitionCode = $MIDAS_DataAcquisitionCode"

     set z [catch {Appdo_GetState} m]           ;#    sys    do_GetState
     if {$MIDAS_DataAcquisitionControlServer_Verbose} {puts "do_GetState returned z=$z and $m"}

      if {$z != 0} {
         set MIDAS_DataAcquisitionCode 6
      } else {
         set MIDAS_DataAcquisitionCode [first $m]
      }
}

#    requires project specific implementation for

#   Appdo_Setup
#   Appdo_Stop
#   Appdo_Go
#   Appdo_Reset
#   Appdo_SetOption
#   Appdo_GetOption
#   Appdo_GetCounters
#   Appdo_GetRates
#   Appdo_GetState


}

package provide RunControlServer 1.0

if {[info exists ::DataAcquisition::PROJECT]} {
    puts "Run Control Server Implementation for [set ::DataAcquisition::PROJECT]"
} else {
    puts "Run Control Server Implementation for undefined project"
}
